if not _G.Rave_Party_Mod then
	_G.Rave_Party_Mod = _G.Rave_Party_Mod or {}
	Rave_Party_Mod._path = ModPath
	Rave_Party_Mod._data_path = SavePath .. "police_rave_party.txt"
	Rave_Party_Mod._settings = {}
	Rave_Party_Mod._settings.active = true
	Rave_Party_Mod._settings.hyper_rave = nil
end


function Rave_Party_Mod:Load()
	local file = io.open(Rave_Party_Mod._data_path, "r")
	if file then
		local decoded = json.decode(file:read("*all")) or {}
		for k, v in pairs(decoded) do
			Rave_Party_Mod._settings[k] = v
		end
		file:close()
	end
end

function Rave_Party_Mod:Save()
	local file = io.open(Rave_Party_Mod._data_path, "w+")
	if file then
		file:write(json.encode(Rave_Party_Mod._settings))
		file:close()
	end
end					

---------------------------------------------- Localization ------------------------------------------------



Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_Rave_Party_Mod", function(loc)

	for _, filename in pairs(file.GetFiles(Rave_Party_Mod._path .. "loc/")) do
		local str = filename:match('^(.*).txt$')
		if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
			loc:load_localization_file(Rave_Party_Mod._path .. "loc/" .. filename)
			break
		end
	end

	loc:load_localization_file(Rave_Party_Mod._path .. "loc/english.txt", false)
end)


----------------------------------------------- Menu ------------------------------------------------------



Hooks:Add("MenuManagerInitialize", "MenuManagerInitialize_Rave_Party_Mod", function(menu_manager)

	MenuCallbackHandler.Rave_Party_Mod_main_callback = function(this,item)
		local name = tostring(item._parameters["name"]):gsub("Rave_Party_Mod_","")
		Rave_Party_Mod._settings[name] = Utils:ToggleItemToBoolean(item)
	end

	MenuCallbackHandler.Rave_Party_Mod_back = function(this, item)
		Rave_Party_Mod:Save()
	end
	
	Rave_Party_Mod:Load()

	-- Main Menu
	Hooks:Add("MenuManagerSetupCustomMenus", "Base_SetupCustomMenus_Json_Rave_Party_Mod_main_menu", function( menu_manager, nodes )
			MenuHelper:NewMenu( "Rave_Party_Mod_main_menu" )
		end)

	Hooks:Add("MenuManagerBuildCustomMenus", "Base_BuildCustomMenus_Json_Rave_Party_Mod_main_menu", function( menu_manager, nodes )

			local parent_menu = "blt_options"
			local menu_id = "Rave_Party_Mod_main_menu"
			local menu_name = "Rave_Party_Mod_main_menu_title"
			local menu_desc = "Rave_Party_Mod_main_menu_desc"

			local data = {
				focus_changed_callback = nil,
				back_callback = "Rave_Party_Mod_back",
				area_bg = nil,
			}
			nodes[menu_id] = MenuHelper:BuildMenu( menu_id, data )

			MenuHelper:AddMenuItem( nodes[parent_menu], menu_id, menu_name, menu_desc, nil )

		end)

	Hooks:Add("MenuManagerPopulateCustomMenus", "Base_PopulateCustomMenus_Json_Rave_Party_Mod_main_menu", function( menu_manager, nodes )
			MenuHelper:AddToggle({
				id = "Rave_Party_Mod_active",
				title = "Rave_Party_Mod_active_title",
				desc = "Rave_Party_Mod_active_desc",
				callback = "Rave_Party_Mod_main_callback",
				value = Rave_Party_Mod._settings.active,
				menu_id = "Rave_Party_Mod_main_menu",
				priority = 2,
				localized = true
			})

			MenuHelper:AddDivider({
				id = "Rave_Party_Mod_divider_0",
				size = 24,
				menu_id = "Rave_Party_Mod_main_menu",
				priority = 1
			})

			MenuHelper:AddToggle({
				id = "Rave_Party_Mod_hyper_rave",
				title = "Rave_Party_Mod_hyper_rave_title",
				desc = "Rave_Party_Mod_hyper_rave_desc",
				callback = "Rave_Party_Mod_main_callback",
				value = Rave_Party_Mod._settings.hyper_rave,
				menu_id = "Rave_Party_Mod_main_menu",
				priority = 0,
				localized = true
			})
		end)
	
end)
